package cz.cvut.fel.k36.pr2.cv02;

/**
 * @author Ondrej Hrstka <ondrej.hrstka@agents.fel.cvut.cz>
 */
public class Bicycle {

    private int cadence;
    private int gear;
    private int speed;

    public int TYPE = 1;

    public Bicycle(int cadence, int gear, int speed) {
        this.cadence = cadence;
        this.gear = gear;
        this.speed = speed;
    }

    public void visit(BikeService service) {
        service.accept(this);
    }

    public void applyBrake(int decrement) {
        speed -= decrement;
    }

    public void speedUp(int increment) {
        speed += increment;
    }

    public int getCadence() {
        return cadence;
    }

    public void setCadence(int cadence) {
        this.cadence = cadence;
    }

    public int getGear() {
        return gear;
    }

    public void setGear(int gear) {
        this.gear = gear;
    }

    public void printDescription() {
        System.out.println("Bicycle{" +
                "cadence=" + cadence +
                ", gear=" + gear +
                ", speed=" + speed +
                '}');
    }

    public static void main(String[] args) {
        Bicycle bike01, bike02, bike03;

        bike01 = new Bicycle(20, 10, 1);
        bike02 = new MountainBike(20, 10, 5, "Dual");
        bike03 = new RoadBike(40, 20, 8, 23);

        bike01.printDescription();
        bike02.printDescription();
        bike03.printDescription();

        BikeService service = new BikeService();

        bike01.visit(service);
        bike02.visit(service);
        bike03.visit(service);

    }
}
